Package com.sas.metadata.remote

# Interface ServiceType

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface ServiceType extends SecondaryType
The types of services available from a DeployedComponent. Examples of types are DBMS, FileSystem, OperatingSystem.

Attributes of ServiceType are:

- `InterfaceName`
- `ClassIdentifier`

Associations of ServiceType are:

- `DeployedComponents`

## Usage

To create an instance of this ServiceType, use the `factory` create methods.
Example: create a ServiceType with name "ServiceType_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     ServiceType myObject = (ServiceType) factory.createComplexMetadataObject(objectStore, "ServiceType_Object", MetadataObjects.SERVICETYPE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_DEPLOYEDCOMPONENTS_NAME`
  Constant used for the name of the DeployedComponents association.
  `static final String`
  `ATTRIBUTE_CLASSIDENTIFIER_NAME`
  Constant used for the name of the ClassIdentifier attribute.
  `static final String`
  `ATTRIBUTE_INTERFACENAME_NAME`
  Constant used for the name of the InterfaceName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getClassIdentifier()`
  Gets the `String` value of `ClassIdentifier`
  `int`
  `getClassIdentifierMaxLength()`
  Gets the maximum length of `ClassIdentifier`
  `int`
  `getClassIdentifierState()`
  Gets the Metadata State of `ClassIdentifier`
  `AssociationList`
  `getDeployedComponents()`
  Gets the Association list of `DeployedComponents`
  `AssociationList`
  `getDeployedComponents(boolean fGoToServer)`
  Gets the Associationlist of `DeployedComponents`
  `String`
  `getInterfaceName()`
  Gets the `String` value of `InterfaceName`
  `int`
  `getInterfaceNameMaxLength()`
  Gets the maximum length of `InterfaceName`
  `int`
  `getInterfaceNameState()`
  Gets the Metadata State of `InterfaceName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setClassIdentifier(String inClassIdentifier)`
  Sets the `ClassIdentifier` value and sets the state to MetadataState.LOCAL.
  `void`
  `setClassIdentifier(String inClassIdentifier, int state)`
  Sets the `ClassIdentifier` Metadata State.
  `void`
  `setClassIdentifierState(int state)`
  Sets the Metadata State of `ClassIdentifier`.
  `void`
  `setDeployedComponents(AssociationList list)`
  Sets the `DeployedComponents` list to be `list`.
  `void`
  `setDeployedComponents(AssociationList inObjects, int state)`
  Sets the entire DeployedComponents list to match the passed in AssociationList, sets the state of the DeployedComponents
  `void`
  `setInterfaceName(String inInterfaceName)`
  Sets the `InterfaceName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setInterfaceName(String inInterfaceName, int state)`
  Sets the `InterfaceName` Metadata State.
  `void`
  `setInterfaceNameState(int state)`
  Sets the Metadata State of `InterfaceName`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_INTERFACENAME_NAME

    static final String ATTRIBUTE_INTERFACENAME_NAME
    Constant used for the name of the InterfaceName attribute.

    InterfaceName: Name of the interface of the component that provides this type of service.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CLASSIDENTIFIER_NAME

    static final String ATTRIBUTE_CLASSIDENTIFIER_NAME
    Constant used for the name of the ClassIdentifier attribute.

    ClassIdentifier: The class identifier is a unique identifier for this component. If this is a Java component, it is the full name of the Java class.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DEPLOYEDCOMPONENTS_NAME

    static final String ASSOCIATION_DEPLOYEDCOMPONENTS_NAME
    Constant used for the name of the DeployedComponents association.

    DeployedComponents: The deployed components that provide this type of service.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getInterfaceName

    String getInterfaceName() throws RemoteException
    Gets the `String` value of `InterfaceName`
    Returns:
      The `InterfaceName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getInterfaceNameState

    int getInterfaceNameState() throws RemoteException
    Gets the Metadata State of `InterfaceName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getInterfaceNameMaxLength

    int getInterfaceNameMaxLength() throws RemoteException
    Gets the maximum length of `InterfaceName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getClassIdentifier

    String getClassIdentifier() throws RemoteException
    Gets the `String` value of `ClassIdentifier`
    Returns:
      The `ClassIdentifier`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getClassIdentifierState

    int getClassIdentifierState() throws RemoteException
    Gets the Metadata State of `ClassIdentifier`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getClassIdentifierMaxLength

    int getClassIdentifierMaxLength() throws RemoteException
    Gets the maximum length of `ClassIdentifier`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDeployedComponents

    AssociationList getDeployedComponents() throws RemoteException, MdException
    Gets the Association list of `DeployedComponents`
    Returns:
      The AssociationList of `DeployedComponents` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDeployedComponents

    AssociationList getDeployedComponents(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `DeployedComponents`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `DeployedComponents` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setInterfaceName

    void setInterfaceName(String inInterfaceName) throws RemoteException
    Sets the `InterfaceName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inInterfaceName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setInterfaceName

    void setInterfaceName(String inInterfaceName, int state) throws RemoteException
    Sets the `InterfaceName` Metadata State.
    Parameters:
      `inInterfaceName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setInterfaceNameState

    void setInterfaceNameState(int state) throws RemoteException
    Sets the Metadata State of `InterfaceName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setClassIdentifier

    void setClassIdentifier(String inClassIdentifier) throws RemoteException
    Sets the `ClassIdentifier` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inClassIdentifier` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setClassIdentifier

    void setClassIdentifier(String inClassIdentifier, int state) throws RemoteException
    Sets the `ClassIdentifier` Metadata State.
    Parameters:
      `inClassIdentifier` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setClassIdentifierState

    void setClassIdentifierState(int state) throws RemoteException
    Sets the Metadata State of `ClassIdentifier`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDeployedComponents

    void setDeployedComponents(AssociationList list) throws RemoteException
    Sets the `DeployedComponents` list to be `list`. Objects of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDeployedComponents

    void setDeployedComponents(AssociationList inObjects, int state) throws RemoteException
    Sets the entire DeployedComponents list to match the passed in AssociationList, sets the state of the DeployedComponents
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.